#!/usr/bin/perl -w -I./blib/lib

use strict;
use DNSSEC::Registry::Trust_DB;
use Term::ReadLine;


my $trustdb=DNSSEC::Registry::Trust_DB->new("ds.isi.edu");

my $term = new Term::ReadLine 'sample';


my @pending_objects=$trustdb->get_pending;

if (! @pending_objects) {
    print "No objects pending\n";
}

foreach my $pending_object ( @pending_objects ){
    print $pending_object->RR->name."+".
	$pending_object->RR->algorithm."+".
	    $pending_object->RR->keytag." is pending\n";
    my $response=$term->readline("trust this key (y|n)?");
    if ($response =~ /Y|y/ ){
	print "Setting trust to trusted\n";
	$pending_object->set_trusted;
	$trustdb->store($pending_object);
    }

}
