#!/usr/bin/perl -I/home/olaf/Development/DS_DB/blib/lib
use Net::DNS;
use Net::DNS::Keyset;
use DNSSEC::Registry::Trust_Container;
use DNSSEC::Registry::Trust_DB;



use strict;

#!/usr/local/bin/perl

use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);

my $domain;

use Net::DNS;
use Data::Dumper;

my %States;
my $Current_Screen;


my $trustdb=DNSSEC::Registry::Trust_DB->new("tld");


%States = (
	   'Cancel'  => \&FrontPage,
	   'Start Again'  => \&FrontPage,
	   'Upload Key' => \&UploadKey,
	   'Select Key' => \&KeySelect,
	   'DS dump' => \&DS_Dump,
	   'Set Trusted' => \&Set_Trusted,
	   'Process Pending' => \&Process_Pending,
	   );


$Current_Screen = param(".State") || "Start Again";
die "No Screen for $Current_Screen" unless $States{$Current_Screen};

standard_header();
while (my ($screen_name,$function)= each %States ){
    $function->($screen_name eq $Current_Screen);
}

standard_footer();
exit;

#___________________________________________________________________________

sub standard_header {
    print header() ."\n";
    
    print start_html( -Title => "Key Upload") ."\n";
    print h1("Prototype Web Registry for DNSSEC key exchanges");
    print start_form() ."\n";
    print hr ."\n";
}


sub standard_footer { 
    print "\n". hr;
    
    print "Demo: ". to_page("DS dump") . " for a dump of the DS records that will be \$INCLUDED<br> ";
    print "Demo: ". to_page("Set Trusted") . " Administrative interface... normally not for mortals<p>";
    print to_page("Start Again");

    print "\n". end_form();
    print "\n". end_html() ."\n";
}



#___________________________________________________________________________

sub to_page { 
    submit(-NAME=>".State", -Value=>shift) ;
}


#___________________________________________________________________________

sub FrontPage {
    my $active=shift;
    return unless $active;
    
    print h1('Key Upload Form'),
    "Please enter the information in the form below",
    p,
    hidden(-name=>'stage',
	   -default=>[1]),
    "What's your domain? ",textfield('domain'),
    p,
    "What's your name? ",textfield('name'),
    p,
    "What's your e-mail address ", textfield('e-mail'),
    p,
    to_page("Select Key");
    
}


#___________________________________________________________________________

sub DS_Dump{
    my $active=shift;
    return unless ($active);
    my @trusted_objects=$trustdb->get_trusted;
    
    print pre("; DS dump for domain: ". $trustdb->domain .".\n;\n;\n");
    
    if (! @trusted_objects) {
	print "; No objects trusted\n";
    }
    
    foreach my $trusted_object ( @trusted_objects ){
	my $dsrr=Net::DNS::RR::DS->create( $trusted_object->RR );
	print  pre ($dsrr->string . "\n")."\n";
	print pre("\n;End of dump\n;\n");
	
    }
}


#___________________________________________________________________________

sub Set_Trusted {
    my $active=shift;
    return unless ($active);
    print h2("Adminitrative interface");
    print "Put trust in keys that have state \"PENDIG\"".
	" This will normally done by a robot which implements the key-exchange
          policy. Off course this page wouldn't be accessible to clients";
    
    my @pending_objects=$trustdb->get_pending;
    
    if (! @pending_objects) {
	print hr ."\n";
	print "No objects pending\n";
    }
    
    my %labels;
    foreach my $pending_object (@pending_objects) {
	my $key=$pending_object->RR;
	
	$labels{$key->keytag}=$key->name . " key-id: " . $key->keytag . 
	    " (algorithm: ".$key->algorithm.")\n";
    }
    
    
    if (keys %labels ){
	print hr ."\n";
	
	print   checkbox_group(-name=>'keys',
			   -values=>\%labels,
			   -linebreak=>'true',
			       );


	print to_page("Process Pending");
    }



    
}


sub Process_Pending {
    
    my $active=shift;
    return unless ($active);   

    my @pending_objects=$trustdb->get_pending;

    my @keytags=param('keys');
    my $got_one=0;
    foreach my $keytag (@keytags){
	foreach my $pending_object (@pending_objects) {
	    my $key=$pending_object->RR;
	    if ($keytag == $key->keytag) {
		print  $key->name . " key-id: " . $key->keytag . 
		" (algorithm: ".$key->algorithm.") is set to trusted<br>\n";
		$got_one=1;
		$pending_object->set_trusted;
		$trustdb->store($pending_object);

	    }
	}
    }
    
    print "No keys set to trusted<br>" unless $got_one;

}


#___________________________________________________________________________


sub DS_Dump{
    my $active=shift;
    return unless ($active);
    my @trusted_objects=$trustdb->get_trusted;

    print pre("; DS dump for domain: ". $trustdb->domain .".\n;\n;\n");
    
    if (! @trusted_objects) {
	print "; No objects trusted\n";
    }
    
    foreach my $trusted_object ( @trusted_objects ){
	my $dsrr=Net::DNS::RR::DS->create( $trusted_object->RR );
	print  pre ($dsrr->string . "\n")."\n";
    }
    print pre("\n;End of dump\n;\n");
    
}
#___________________________________________________________________________

sub KeySelect {
    my $active=shift;
    return unless ($active);
    
    return if ParameterMissing ("domain", "Start Again") ;
    return if ParameterMissing ("name", "Start Again") ;
    return if ParameterMissing ("e-mail", "Start Again") ;
    
    my $domain=param('domain') ;
    my $name=param('name') ;
    my $email=param('e-mail') ;
    
    my $keyset=get_keyset($domain);
    my @keyrr=$keyset->keys;
    my @sigrr=$keyset->sigs;

    my %labels;
    my $key;


    my $state_is_trusted=0;
    my $state_is_pending=0;

    print h2("Key selection page");
    print hr. h3("Keys allready known to our database");
    if (@keyrr){
	foreach $key ( @keyrr ) {
	    print "<table border=0><tr><td>";
	    if (my @trustobj=$trustdb->get($key->name,$key->algorithm,$key->keytag)){

		# OMK there is a potential problem here: There can be
		# clashces in the keytag, so multiple entries can be
		# returned here, The keytag is a identifyer. It can
		# happen that a new key has this keytag this needs
		# some additional checking $state_is_trusted=1 if
		# $trustobj[0]->is_trusted;

		print em ( $key->name . " key-id: " . $key->keytag . 
			   " (algorithm: ".$key->algorithm.")");
		print "</td><td> This key is allready in the database
                                and can thus not be uploaded<br>";
		print "This key's state is ".
		    $trustobj[0]->get_currentstate_string.
			"</td></tr></table>\n";

		$state_is_trusted=$trustobj[0]->RR->keytag if 
		    $trustobj[0]->is_trusted;

		 $state_is_pending=$trustobj[0]->RR->keytag if 
		     $trustobj[0]->is_pending;

	     }else{
		 $labels{$key->keytag}=$key->name . " key-id: " . $key->keytag . 
		     " (algorithm: ".$key->algorithm.")\n";
	     }
	 }


	 if (keys %labels ){
	     print hr ."\n";
	     print h3("Keys to generate DS records for");

	     if ($state_is_pending){
		 print "You have a key PENDING for authentication<br>";
		 print "You may not upload a second key<br>";
	     }else{

		 print "You can choose from ONE of the following keys:<br>\n";
		 if  ($state_is_trusted ){	
		     print "<font color=\"red\">\n";
		     print "The newly selected key will replace the key with key-id " .$state_is_trusted;
		     print "</font><p>\n";
		 }


		 print
		     radio_group(-name=>'keys',
				 -values=>\%labels,
				 -linebreak=>'true',
				 ),
		     
		     "\n", p ;
		 
		 print hidden(-name=>'domain',
			      -default=>[$domain]);
		 print hidden(-name=>'name',
			      -default=>[$name]);
		 print hidden(-name=>'e-mail',
			      -default=>[$email]);
		 
		 print to_page("Upload Key") unless $state_is_pending;
		 print to_page("Cancel");
	     }
	     
     	 }else{
	     print "<p>No keys to be uploaded<p>";
	     print to_page("Start Again");
	 }
    }else{
	print "<p>No keys found in your zone<p>";
	print to_page("Start Again");
    }
    print hr;
    
    print h3("Some debugging help");

    print "<Font Size=-2>We uploaded the following key<br>";
    my $key;
	
    foreach $key ( @keyrr ) {
	print $key->name . " key-id: " . $key->keytag . 
	    " (algorithm: ".$key->algorithm.") <br>\n";
    }


    print "<Font Size=-2>These keys where signed with<br>";
    my $sig;
	
    foreach $sig ( @sigrr ) {
	print $sig->name . " key-id: " . $sig->keytag . 
	    " (algorithm: ".$sig->algorithm.") <br>\n";
    }

    print "\n</Font>\n";

    print "<Font Size=-2>If you do not find the appropriate key above
    it may well be that it did not make it to the caching forwarder
    our system is querying from. You have to wait untill the changes
    to your zone have propagated and the data has timed out from our
    cache before you can select the appropriate key.</Font><p>\n";

}

#___________________________________________________________________________

sub UploadKey {
    my $active=shift;
    return unless ($active);

    return if ParameterMissing ("domain", "Start Again") ;
    my $domain=param('domain');
    return if ParameterMissing ("name", "Start Again") ;
    my $name=param('name');
    return if ParameterMissing ("e-mail", "Start Again") ;
    my $email=param('e-mail');    


    if (!param('keys')){
	print "You did not select a key. That is a seriously weird error";
	print "If you are trying to circumvent the webpage your query is\n";
	print "logged. If you get this error during a regular transaction\n";
	print "then please report this errror to ....". hr;
	print "Click on your browsers back button or\n";

	print to_page("Start Again");
	return 1;
    }
    
    my $keyset=get_keyset($domain);
    my @keyrr=$keyset->keys;
    my  $keytag=(param('keys'));
    #
    #  Do some bounds checking here...
    #

    foreach my $key (@keyrr){
	if ($keytag==$key->keytag){
	    
	    print "<table border=1>\n";
	    print "<tr><td colspan=2>The following key has been uploaded <td> </tr>\n";
	    print "<tr><td>Keytag</td><td>representation</td></tr>\n";
	    print "<tr><td>". $keytag ."</td><td>".
		pre($key->string)." </td></tr>\n";
	    print "</table>\n";
	    my $trust=DNSSEC::Registry::Trust_Container->new($key);
	    #Double check if any of the keys in the keyset can be trusted.
	    #In that case we have to do a little more processing.


	    if ($trustdb->any_trusted($keyset)){
		print "<table border=1>\n<tr><td colspan=2>";
		print "We set the state of the following key to EXPIRE:</td><tr>\n";
		print "<tr><td>Keytag</td><td>representation</td></tr>\n";
		foreach my $current_trust_object ($trustdb->get($domain)){
		    if ($current_trust_object->is_trusted){
			
			print "<tr><td>".$current_trust_object->RR->keytag .
			    "</td><td>". pre($current_trust_object->RR->string).
				" </td></tr>\n" ;
			$current_trust_object->set_t_end(time());
			$current_trust_object->add_history("object set to EXPIRED via HTTP user: $name ($email)");
			$trustdb->store($current_trust_object);
			$trust->set_trusted;
		    }
		}
		print "</table>\n";
		
	    }

      	    $trust->add_history("object via HTTP user: $name ($email)");
	    $trustdb->store($trust);
	}
    }
    print "</table>\n";
    print "\n<p>The request is queued for further processing. You will be notified.<p>\n";

    print to_page("Start Again");
}    
#___________________________________________________________________________



sub ParameterMissing {
    my $parameter=shift;
    my $state=shift;
    
    if (! param($parameter) ){

	print "Parameter \"".$parameter."\" is missing<p>".
	    "Go to the appropriate form by pressing the button <p>";
	print to_page($state);

	return 1;
	

    }
    return 0;
}







sub get_keyset {
    my $domain=shift;

    my $res = Net::DNS::Resolver->new;
    $res->dnssec(1);
    $res->nameservers("127.0.0.1");
    my $packet = $res->query($domain, 'KEY', 'IN');
    if (! defined $packet){
	print "No results for query " , em("QNAME=$domain   QTYPE=KEY") ;
	print "<br>\n" . to_page("Start Again") . hr;
	exit 1;
    }
    
    my $keyset=Net::DNS::Keyset->new($packet) ;
    
    if ( ! $keyset ){
	$|=1;
	print start_html('Key Exchange');
	print h1('Key Error'),
	hr ,
	"Loading keyset failed because: " , p ,
	tt($Net::DNS::Keyset::keyset_err),
	hr;
	print end_html;
	exit 0;
    }

    if ( ! $keyset->verify ){
	print h1("Verification problem");
	print "The selfsignature of the keys in the keyset do not verify<p>\n";
	print "Indication of the error: ".$Net::DNS::Keyset::keyset_err."\n";
	print "\n<hr>\n";
	print h3("Data uploaded (Query $domain KEY):<br>\n");
	print pre($keyset->string);
	print hr;
	my @sigs=$keyset->sigs;
	print "Note that it may take up to ". $sigs[0]->ttl ." seconds before this keyset has expired from our cache and your changes are picked up.\n";
	print "\n". hr . "\n";
	print to_page("Start Again");
	exit 0
	}


    return $keyset;

}



